package edu.ndsu.cs.hayden.christensonAssignment3.cayenne.persistent.auto;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Date;
import java.util.List;

import org.apache.cayenne.BaseDataObject;
import org.apache.cayenne.exp.Property;

import edu.ndsu.cs.hayden.christensonAssignment3.cayenne.persistent.Advisor;
import edu.ndsu.cs.hayden.christensonAssignment3.cayenne.persistent.Course;

/**
 * Class _Student was generated by Cayenne.
 * It is probably a good idea to avoid changing this class manually,
 * since it may be overwritten next time code is regenerated.
 * If you need to make any customizations, please use subclass.
 */
public abstract class _Student extends BaseDataObject {

    private static final long serialVersionUID = 1L; 

    public static final String PK_PK_COLUMN = "PK";

    public static final Property<Date> DATE_OF_BIRTH = Property.create("dateOfBirth", Date.class);
    public static final Property<Double> GPA = Property.create("gpa", Double.class);
    public static final Property<String> MAJOR = Property.create("major", String.class);
    public static final Property<String> NAME = Property.create("name", String.class);
    public static final Property<Integer> STUDENT_ID = Property.create("studentID", Integer.class);
    public static final Property<Advisor> ADVISOR = Property.create("advisor", Advisor.class);
    public static final Property<List<Course>> COURSES = Property.create("courses", List.class);

    protected Date dateOfBirth;
    protected Double gpa;
    protected String major;
    protected String name;
    protected Integer studentID;

    protected Object advisor;
    protected Object courses;

    public void setDateOfBirth(Date dateOfBirth) {
        beforePropertyWrite("dateOfBirth", this.dateOfBirth, dateOfBirth);
        this.dateOfBirth = dateOfBirth;
    }

    public Date getDateOfBirth() {
        beforePropertyRead("dateOfBirth");
        return this.dateOfBirth;
    }

    public void setGpa(double gpa) {
        beforePropertyWrite("gpa", this.gpa, gpa);
        this.gpa = gpa;
    }

    public double getGpa() {
        beforePropertyRead("gpa");
        if(this.gpa == null) {
            return 0;
        }
        return this.gpa;
    }

    public void setMajor(String major) {
        beforePropertyWrite("major", this.major, major);
        this.major = major;
    }

    public String getMajor() {
        beforePropertyRead("major");
        return this.major;
    }

    public void setName(String name) {
        beforePropertyWrite("name", this.name, name);
        this.name = name;
    }

    public String getName() {
        beforePropertyRead("name");
        return this.name;
    }

    public void setStudentID(int studentID) {
        beforePropertyWrite("studentID", this.studentID, studentID);
        this.studentID = studentID;
    }

    public int getStudentID() {
        beforePropertyRead("studentID");
        if(this.studentID == null) {
            return 0;
        }
        return this.studentID;
    }

    public void setAdvisor(Advisor advisor) {
        setToOneTarget("advisor", advisor, true);
    }

    public Advisor getAdvisor() {
        return (Advisor)readProperty("advisor");
    }

    public void addToCourses(Course obj) {
        addToManyTarget("courses", obj, true);
    }

    public void removeFromCourses(Course obj) {
        removeToManyTarget("courses", obj, true);
    }

    @SuppressWarnings("unchecked")
    public List<Course> getCourses() {
        return (List<Course>)readProperty("courses");
    }

    @Override
    public Object readPropertyDirectly(String propName) {
        if(propName == null) {
            throw new IllegalArgumentException();
        }

        switch(propName) {
            case "dateOfBirth":
                return this.dateOfBirth;
            case "gpa":
                return this.gpa;
            case "major":
                return this.major;
            case "name":
                return this.name;
            case "studentID":
                return this.studentID;
            case "advisor":
                return this.advisor;
            case "courses":
                return this.courses;
            default:
                return super.readPropertyDirectly(propName);
        }
    }

    @Override
    public void writePropertyDirectly(String propName, Object val) {
        if(propName == null) {
            throw new IllegalArgumentException();
        }

        switch (propName) {
            case "dateOfBirth":
                this.dateOfBirth = (Date)val;
                break;
            case "gpa":
                this.gpa = (Double)val;
                break;
            case "major":
                this.major = (String)val;
                break;
            case "name":
                this.name = (String)val;
                break;
            case "studentID":
                this.studentID = (Integer)val;
                break;
            case "advisor":
                this.advisor = val;
                break;
            case "courses":
                this.courses = val;
                break;
            default:
                super.writePropertyDirectly(propName, val);
        }
    }

    private void writeObject(ObjectOutputStream out) throws IOException {
        writeSerialized(out);
    }

    private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
        readSerialized(in);
    }

    @Override
    protected void writeState(ObjectOutputStream out) throws IOException {
        super.writeState(out);
        out.writeObject(this.dateOfBirth);
        out.writeObject(this.gpa);
        out.writeObject(this.major);
        out.writeObject(this.name);
        out.writeObject(this.studentID);
        out.writeObject(this.advisor);
        out.writeObject(this.courses);
    }

    @Override
    protected void readState(ObjectInputStream in) throws IOException, ClassNotFoundException {
        super.readState(in);
        this.dateOfBirth = (Date)in.readObject();
        this.gpa = (Double)in.readObject();
        this.major = (String)in.readObject();
        this.name = (String)in.readObject();
        this.studentID = (Integer)in.readObject();
        this.advisor = in.readObject();
        this.courses = in.readObject();
    }

}
